// Libraries: ws2_32.lib user32.lib
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <winsock2.h>
#include <winbase.h>

#define PUERTO	8000

int TestServicio(void)
{
  SC_HANDLE						schService;
  SC_HANDLE						schSCManager;
	SERVICE_STATUS			Estado;
	
	schSCManager = OpenSCManager(NULL, NULL, GENERIC_READ);
	if(schSCManager == NULL)
	{
		// Dont open service manager. Finish
		return -1;
	}

	schService = OpenService(schSCManager,(LPCTSTR)"runserv", SERVICE_QUERY_STATUS);
	if(schService == NULL)
	{
		// Dont find runserv. Finish
		CloseServiceHandle(schSCManager);
		return -1;
	}

	// Runserv status
	QueryServiceStatus(schService, &Estado);
	if(Estado.dwCurrentState == SERVICE_RUNNING)
	{
		// runserv OK
		CloseServiceHandle(schSCManager);
		return 0;
	}
	else
	{
		// runserv is not started. Error
		CloseServiceHandle(schSCManager);
		return -1;
	}
}

void Ayuda(void)
{
	system("cls");
	printf("Syntax: runasv <Command to execute> [-h] <Machine> <User> <Password>\n");
	printf("        [-h]: Hide mode.\n");
	printf("        Machine: IP addreess or machine name.\n");	
	printf("        User: [\\Domain\\]User for executing command.\n");
	printf("        Password: password.\n");
	
	return;
}


int main(int argc, char **argv)
{
	char						szPath[MAX_PATH], szServidor[MAX_PATH], szBuffer[MAX_PATH], szDominio[MAX_PATH];
	char						szComando[MAX_PATH], szUsuario[MAX_PATH], szPassword[MAX_PATH], szMensaje[MAX_PATH];
	char						szMaquina[MAX_PATH];
	char						szRetorno[20];
	struct sockaddr_in dirEnvio;
	struct					hostent *hp;
	WSADATA					wsaData;
	SOCKET					idSocket;
	BOOL						bVisible, bPregunta, bLocal;
	int							c, i, j, iError;
	DWORD						dwSize;
	unsigned int		addr;

	// Reads program parameters
	if((argc < 2) || (argc > 6))
	{
		Ayuda();
		return -1;
	}

	memset(szBuffer, 0, MAX_PATH);
	memset(szDominio, 0, MAX_PATH);
	memset(szUsuario, 0, MAX_PATH);
	memset(szPassword, 0, MAX_PATH);

	dwSize = sizeof(szMaquina);

	if(argc == 3)
	{
		if(stricmp("-h", argv[2]) == 0)
		{
			// Command-Mode
			// Checks execution mode

			// Command is the first argument
			strcpy(szComando, argv[1]);

			// Local machine
			bLocal = TRUE;

			// Execution mode
			bVisible = FALSE;

			// Asks for User and Password
			bPregunta = TRUE;
		}
		else
		{
			// Command-Machine
			// Command is first argument
			strcpy(szComando, argv[1]);

			// Remote machine
			bLocal = FALSE;
			strcpy(szMaquina, argv[2]);

			// Execution mode to visible (default)
			bVisible = TRUE;

			// Asks for User and Password
			bPregunta = TRUE;
		}
	}
	else if(argc == 4)
	{
		if(stricmp("-h", argv[2]) == 0)
		{
			// Command-Mode-Machine
			// Command is first argument
			strcpy(szComando, argv[1]);

			// Execution mode
			bVisible = FALSE;

			// Remote machine
			bLocal = FALSE;
			strcpy(szMaquina, argv[3]);

			// Asks for User and Password
			bPregunta = TRUE;
		}
		else
		{
			// Command-User-Password
			// Command is first argument
			strcpy(szComando, argv[1]);

			// Execution mode to visible (default)
			bVisible = TRUE;

			// Local machine
			bLocal = TRUE;

			// User is second argument
			strcpy(szUsuario, argv[2]);

			// Password is third argument
			strcpy(szPassword, argv[3]);

			// Dont ask for User and Password
			bPregunta = FALSE;
		}
	}
	else if(argc == 5)
	{
		// Checks execution mode
		if(stricmp("-h", argv[2]) == 0)
		{
			// Command-Mode-User-Password
			// Command is first argument
			strcpy(szComando, argv[1]);

			// Execution mode to hide
			bVisible = FALSE;

			// Local machine
			bLocal = TRUE;

			// User is third argument
			strcpy(szUsuario, argv[3]);

			// Password is fourth argument
			strcpy(szPassword, argv[4]);

			// Dont ask for User and Password
			bPregunta = FALSE;
		}
		else
		{
			// Command-Machine-User-Password
			// Command is first argument
			strcpy(szComando, argv[1]);

			// Execution mode to visible (default)
			bVisible = TRUE;

			// Remote machine
			bLocal = FALSE;
			strcpy(szMaquina, argv[2]);

			// User is third argument
			strcpy(szUsuario, argv[3]);

			// Password is fourth argument
			strcpy(szPassword, argv[4]);

			// Dont ask for User and Password
			bPregunta = FALSE;
		}
	}
	else if(argc == 6)
	{
		// Checks execution mode
		if(stricmp("-h", argv[2]) == 0)
		{
			// Command-Mode-Machine-User-Password
			// Command is first argument
			strcpy(szComando, argv[1]);

			// Execution mode to hide
			bVisible = FALSE;

			// Remote machine
			bLocal = FALSE;
			strcpy(szMaquina, argv[3]);

			// User is third argument
			strcpy(szUsuario, argv[4]);

			// Password is fourth argument
			strcpy(szPassword, argv[5]);

			// Dont ask for User and Password
			bPregunta = FALSE;
		}
		else
		{
			Ayuda();
			return -1;
		}
	}
	else
	{
		// Mode visible (default)
		bVisible = TRUE;

		// Command is first argument
		strcpy(szComando, argv[1]);

		// Local machine
		bLocal = TRUE;

		// Asks for User and Password
		bPregunta = TRUE;
	} // if(argc == 3)

	if(bPregunta == TRUE)
	{
		// Asks User
		printf("User: ");
		i=0;
		while(1)
		{
			c = _getch();
			
			// If reads 0x0 or 0xe0 it is a special key and it has to call getch again
			if((c==0) || (c==0xe0))
			{
				_getch();
			}
			else if((c==0xd) || (i==MAX_PATH))
			{
				break;
			}
			else
			{
				if(iscntrl(c)==0)
				{
					// It is not a control key
					_putch(c);
					szUsuario[i]=c;
					i++;
				}
				else if((c=0x8) && (i>0))
				{
					// Delete
					_putch(c);
					putch(0x20);
					_putch(c);
					szUsuario[i]=0;
					i--;
				} // if(iscntrl(c)==0)
			} // if((c==0) || (c==0xe0))
		} // while

		// Asks password
		printf("\nPassword: ");
		i=0;
		while(1)
		{
			c = _getch();
			
			// If reads 0x0 or 0xe0 it is a special key and it has to call getch again
			if((c==0) || (c==0xe0))
			{
				_getch();
			}
			else if((c==0xd) || (i==MAX_PATH))
			{
				break;
			}
			else
			{
				if(iscntrl(c)==0)
				{
					// it is not a control key
					_putch('*');
					szPassword[i]=c;
					i++;
				}
				else if((c=0x8) && (i>0))
				{
					// Delete
					_putch(c);
					_putch(0x20);
					_putch(c);
					szPassword[i]=0;
					i--;
				} // if(iscntrl(c)==0)
			} // if((c==0) || (c==0xe0))
		} // while
	} // if(bPregunta == TRUE)

	printf("\nRunning %s...", szComando);

	// Checks domain
	if(szUsuario[0] == '\\')
	{
		for(i=1; szUsuario[i]!= '\\'; i++)
		{
			szDominio[i-1] = szUsuario[i];
		}

		for(j=i+1; szUsuario[j]!=0; j++)
		{
			szUsuario[j-i-1] = szUsuario[j];
		}
		for(i=j-i-1; i<MAX_PATH; i++)
		{
			szUsuario[i] = 0;
		}
	}

	// Obtains current directory
	GetCurrentDirectory(MAX_PATH, szPath);

	// Checks if runserv service is started
	if(TestServicio() != 0)
	{
		printf("\nProblems with runserv service\n");
		return -1;
	}

	// Initialize WS2_32.DLL librarie
	if(WSAStartup(0x202, &wsaData) == SOCKET_ERROR)
	{
		printf("\nError %d in WSAStartup()\n",WSAGetLastError()); 
		return -1;
	}

	// Obtains the machine name (if it is local)
	if(bLocal == TRUE)
	{
		// Local machine
		if(gethostname(szServidor, MAX_PATH) == SOCKET_ERROR)
		{
			printf("\nError %d in gethostname()\n",WSAGetLastError()); 
			WSACleanup();
			return -1;
		}
	}
	else
	{
		// Remote machine
		// Obtains the machine name
		if(isalpha(szMaquina[0]) != 0)
		{
			// Input is the machine name
			strcpy(szServidor, szMaquina);
		}
		else 
		{
			// Input is the IP address. Obtains the machine name
			addr = inet_addr(szMaquina);
			hp = gethostbyaddr((char *)&addr, 4, AF_INET);
			if(hp == NULL)
			{
				// Error
				printf("\nError %d in gethostbyaddr()\n",WSAGetLastError()); 
				WSACleanup();
				return -1;
			}
			else
			{
				// Name correct
				memset(szServidor, 0, MAX_PATH);
				for(i=0; (hp->h_name[i]!=0) && (hp->h_name[i]!='.') && (i<MAX_PATH); i++)
				{
					szServidor[i] = hp->h_name[i];
				}
			} // if(hp == NULL)
		} // if(isalpha(szMaquina[0]) != 0)
	} // if(bLocal == TRUE)

	// Creates a socket
	idSocket = socket(AF_INET, SOCK_STREAM, 0);
	if(idSocket == INVALID_SOCKET)
	{
		printf("\nError %d in socket()\n",WSAGetLastError()); 
		WSACleanup();
		return -1;
	}

	// Obtains IP address
	hp = gethostbyname(szServidor);
	
	if(hp == NULL)
	{
		printf("\nError %d in gethostbyname()\n",WSAGetLastError());
		closesocket(idSocket);
		WSACleanup();
		return -1;
	}

	memset(&dirEnvio, 0, sizeof(dirEnvio));
	memcpy((char FAR *)&(dirEnvio.sin_addr), hp->h_addr, hp->h_length);
	dirEnvio.sin_family = AF_INET;
	dirEnvio.sin_port = htons(PUERTO);

	// Establish a connection
	if(connect(idSocket, (PSOCKADDR)&dirEnvio, sizeof(dirEnvio)) == SOCKET_ERROR)
	{
		printf("\nError %d in connect()\n",WSAGetLastError()); 
		closesocket(idSocket);		
		WSACleanup();
		return -1;
	}

	// Builds the string to send
	strcpy(szBuffer, szComando);
	szBuffer[strlen(szBuffer)] = 0xa;
	strcat(szBuffer, szPath);
	szBuffer[strlen(szBuffer)] = 0xa;
	if(bVisible == TRUE)
	{
		strcat(szBuffer, "VISIBLE");
	}
	else
	{
		strcat(szBuffer, "OCULTO");	
	}
	szBuffer[strlen(szBuffer)] = 0xa;
	strcat(szBuffer, szUsuario);
	szBuffer[strlen(szBuffer)] = 0xa;
	strcat(szBuffer, szPassword);
	szBuffer[strlen(szBuffer)] = 0xa;
	strcat(szBuffer, szDominio);
	szBuffer[strlen(szBuffer)] = 0xa;

	if((send(idSocket, szBuffer, strlen(szBuffer), 0)) == SOCKET_ERROR)
	{
		printf("\nError %d in send()\n",WSAGetLastError());
		closesocket(idSocket);
		WSACleanup();
		return -1;
	}

	// Waits an answer
	memset(szBuffer, 0, MAX_PATH);
  if(recv(idSocket, szBuffer, MAX_PATH, 0) == SOCKET_ERROR)
	{
		// Checks if there are data to receive
		iError = WSAGetLastError();
		if(iError == WSAEWOULDBLOCK)
		{
			// There are not data. Dont do anything
		}
		else
		{
			// Error is different from there are not data to receive
			printf("Error %d in recv().\n", iError);
		} // if(rc == WSAEWOULDBLOCK)
	}
	else
	{
		// Shows return message
		memset(szRetorno, 0, 20);
		memset(szMensaje, 0, MAX_PATH);

		for(i=0; (szBuffer[i]!=0xa) && (i<(int)strlen(szBuffer)); i++)
		{
			szRetorno[i] = szBuffer[i];
		}

		for(j=i+1; (szBuffer[j]!=0xd) && (szBuffer[j]!=0xa) && (j<(int)strlen(szBuffer)); j++)
		{
			szMensaje[j-i-1] = szBuffer[j];
		}

		// Correct reception
		if(stricmp(szRetorno, "OK") != 0)
		{
			// Error
			CharToOem(szMensaje, szMensaje);
			printf("\nError in command execution:\n%s", szMensaje);
		}
		else
		{
			// OK
			printf("\nCommand correctly executed.");
		}
	}

	if(bLocal == FALSE)
	{
		CharToOem("Machine", szMensaje);
		printf(" (%s %s).\n", szMensaje, szServidor);
	}

	// Closes socket
	closesocket(idSocket);
	WSACleanup();

	return 0;
}